module BranchableCDNAssets
  class Config

    module EnvironmentAttributeReader

      def env_attr key
        environments.fetch(env.to_sym, {})
                    .fetch(key, nil)
      end

      module ClassMethods
        def env_attr_reader *keys
          keys.each do |key|
            define_method key do
              if env_attr(key).nil?
                raise( ArgumentError, "No key '#{key.to_s}' exists for '#{env}'" )
              else
                env_attr(key)
              end
            end
          end
        end
      end
    end

  end
end