module BranchableCDNAssets
  module Invalidator

    class << self
      def invalidators
        @_invalidators ||= {}
        return @_invalidators
      end

      def register invalidator_key, invalidator_class
        invalidators[invalidator_key] = invalidator_class
      end

      def find invalidator_key
        invalidators.fetch invalidator_key, false
      end
    end

  end
end

require_relative 'invalidator/base'
require_relative 'invalidator/cloudfront'
require_relative 'invalidator/akamai_ccu'