module BranchableCDNAssets
  module Invalidator
    class Cloudfront < Base

      register_as :cloudfront
      require_keys [:distribution_id, :access_key, :secret_key]

      def cdn
        @cdn ||= ::Fog::CDN.new provider: 'AWS',
                                aws_access_key_id: config.access_key,
                                aws_secret_access_key: config.secret_key
      end

      # invalidate a batch of files on fog
      # @param files [Array]
      def invalidate_files files
        resp = cdn.post_invalidation( config.distribution_id, Array(files) )
        resp.body["InvalidationBatch"]["Path"].each do |file|
          puts "Posted an invalidation for #{file}".colorize( :green )
        end
      end

    end
  end
end